<template>
  <v-app-bar :class="['app-header', 'pr-5']" fixed elevation="2">
    <v-toolbar-title :class="['app-header__logo', 'ml-5 mr-10 mt-9']">
      <nuxt-link to="/" data-cy="home-link">
        <v-img :src="require('~/assets/images/logo3.svg')" contain :max-height="90" aspect-ratio="1"></v-img>
      </nuxt-link>
    </v-toolbar-title>

    <v-tabs class="main-menu ml-10" optional>
      <v-tab
        v-for="(item, i) in menuItems"
        :key="`main-menu-${i}`"
        v-ripple="{ class: `pink--text` }"
        nuxt
        :to="item.link"
        :class="item.ref"
        :disabled="item.active"
        :data-cy="item.cypress"
        v-text="item.title"
      >
      </v-tab>
    </v-tabs>

    <!-- <div>
      <feedback-button></feedback-button>
    </div> -->

    <v-spacer></v-spacer>

    <client-only>
      <v-tooltip bottom>
        <template v-slot:activator="{ on }">
          <v-btn text icon color="red darken-2" nuxt to="/catalog/wishlist" v-on="on">
            <v-icon>mdi-cards-heart</v-icon>
          </v-btn>
        </template>
        <span>{{ $t('text.wishlist') }}</span>
      </v-tooltip>

      <!-- <v-tooltip bottom>
        <template v-slot:activator="{ on }">
          <v-btn text icon color="amber darken-4" nuxt to="/user/compare" v-on="on">
            <v-icon>mdi-select-compare</v-icon>
          </v-btn>
        </template>
        <span>{{ $t('text.compare') }}</span>
      </v-tooltip> -->

      <div v-if="cartItemsTotal" class="app-header__cart-btn">
        <v-tooltip bottom>
          <template v-slot:activator="{ on }">
            <v-badge color="pink" :content="cartItemsTotal">
              <v-btn text icon color="light-blue darken-1" @click="goToCart" v-on="on">
                <v-icon>mdi-cart</v-icon>
              </v-btn>
            </v-badge>
          </template>
          <span>{{ $t('text.cart') }}</span>
        </v-tooltip>
      </div>

      <!-- <v-tooltip bottom>
      <template v-slot:activator="{ on }">
        <v-btn text icon color="indigo" @click="searchOverlay = !searchOverlay" v-on="on">
          <v-icon>mdi-magnify</v-icon>
        </v-btn>
      </template>
      <span>{{ $t('text.search') }}</span>
    </v-tooltip> -->
    </client-only>
  </v-app-bar>

  <!-- <v-app-bar app color="white" hide-on-scroll inverted-scroll>
      <v-app-bar-nav-icon></v-app-bar-nav-icon>

      <v-toolbar-title>
        <nuxt-link to="/">
          <v-img :src="require('~/assets/images/logo2.svg')" contain max-width="120"></v-img>
        </nuxt-link>
      </v-toolbar-title>

      <v-tabs optional class="ml-10">
        <v-tab v-for="item in menuItems" :key="item.id" nuxt :to="item.link" class="font-weight-light">
          {{ item.title }}
        </v-tab>
      </v-tabs>

      <v-spacer></v-spacer>

      <v-btn text icon>
        <v-icon>mdi-dots-vertical</v-icon>
      </v-btn>
    </v-app-bar> -->

  <!-- <v-overlay :value="searchOverlay" opacity="0.9" class="search-wrapper">
      <v-btn text icon large @click="searchOverlay = false">
        <v-icon>mdi-close</v-icon>
      </v-btn>
      <search-form></search-form>
    </v-overlay> -->
</template>

<script>
export default {
  data: () => ({
    mainMenuTab: '/',
    searchOverlay: false,
  }),

  computed: {
    themeDark() {
      return this.$store.state.themeDark
    },

    snackbar() {
      return this.$store.state.snackbar
    },

    mainMenu() {
      const { MENU_KEYS = {} } = process.env
      const { main: key = 'main_menu' } = MENU_KEYS
      return this.$store.state.layout[key] || []
    },

    menuItems() {
      const { pages } = this.$store.state
      const items = this.mainMenu.map(item => {
        const link = (item.field.type === 'collectionlink'
          ? pages.find(page => page._id === item.value._id).slug
          : item.value.link
        ).replace(/^\//, '')
        const path = `/${link}`

        return {
          id: item.value._id,
          title: item.value.display,
          link: path,
          ref: `main-menu-item-${link}`,
          active: this.$route.path === path,
          cypress: `main-menu__${link}`,
        }
      })

      return items
    },

    cartItemsTotal() {
      const { cart = [] } = this.$store.state.catalog
      return cart.length
    },

    catalogBaseUrl() {
      return process.env.CATALOG_BASE_URL
    },
  },

  methods: {
    goToCart() {
      const { cart } = this.$store.state.catalog

      if (cart.length) {
        this.$router.push(`${this.catalogBaseUrl}/cart`)
      } else {
        this.$store.commit('SET_SNACKBAR', {
          color: 'deep-orange',
          text: this.$t('text.cart-empty'),
        })
      }
    },
  },
}
</script>

<style lang="scss">
.app-header {
  background-color: rgba(255, 255, 255, 0.7) !important;

  &__logo {
    width: 420px;
    transition: all 0.2s ease-in-out;
  }

  &.v-app-bar--is-scrolled {
    // background-color: white !important;

    .app-header__logo {
      width: 195px;
      transform: translateY(-8px);
    }
  }

  .main-menu {
    .v-tab {
      background: #fff;
      color: rgba(0, 0, 0, 0.7);
      font-weight: 300;

      &--active {
        color: #000;
        font-weight: 500;
      }
    }
  }

  &__cart-btn {
    .v-badge__badge {
      transform: translate(-10px, 15px);
    }
  }
}

/* .search-wrapper .v-overlay__content {
  width: 100%;
  height: 100%;
  position: absolute;
}

.search-wrapper .v-btn {
  position: absolute;
  top: 23px;
  right: 23px;
}

.search-wrapper__form {
  margin-top: 20%;
} */
</style>
